const test = require('ava')

const checkLockFiles = require('./check-lock-files')

const { setupMockRegistry, clearMockRegistry } = require('../mocks/registry/setup-registry')
const { setupMockFS, clearMockFS, mockFile } = require('../mocks/filesystem/setup-filesystem')

// The mock registry contains all packages used in the tests below
// If you add a new test, please use one of the existing packages
// or refer to the ./mocks/registry README to add a new package to
// the mock registry.
test.before(() => { setupMockRegistry(); setupMockFS() })

test.after(() => { clearMockRegistry(); clearMockFS() })

function checkMockedFile (path, content) {
  mockFile(path, content)
  return checkLockFiles([path])
}

test('yarn@v1: correctly parses lock file', async t => {
  const result = await checkMockedFile('/yarn-v1/correct/yarn.lock',
    `
# THIS IS AN AUTOGENERATED FILE. DO NOT EDIT THIS FILE DIRECTLY.
# yarn lockfile v1


lodash@^4.17.20:
  version "4.17.20"
  resolved "https://registry.yarnpkg.com/lodash/-/lodash-4.17.20.tgz#b44a9b6297bcb698f1c51a3545a2b3b368d59c52"
  integrity sha512-PlhdFcillOINfeV7Ni6oF1TAEayyZBoZ8bcshTHqOYJYlrqzRK5hagpagky5o4HfCzzd1TRkXPMFq6cKk9rGmA==`
  )

  t.deepEqual(result, [])
})

test('yarn@v1: should create error on unparsable file', async t => {
  const file = '/yarn-v1/incorrect/yarn.lock'
  const result = await checkMockedFile(file, ';unparsable')

  t.deepEqual(result, [
    {
      file,
      message: `Could not parse lockfile: Unknown token: { line: 1, col: 0, type: 'INVALID', value: undefined } 1:0 in ${file}`,
      type: 'ERROR'
    }
  ])
})

test('yarn@v1: should create error on file with merge conflict', async t => {
  const file = '/yarn-v1/conflict/yarn.lock'
  const result = await checkMockedFile(file,
    `
# THIS IS AN AUTOGENERATED FILE. DO NOT EDIT THIS FILE DIRECTLY.
# yarn lockfile v1


<<<<<<< HEAD
lodash@^4.17.19:
=======
lodash@^4.17.20:
>>>>>>> branch-a
  version "4.17.20"
  resolved "https://registry.yarnpkg.com/lodash/-/lodash-4.17.20.tgz#b44a9b6297bcb698f1c51a3545a2b3b368d59c52"
  integrity sha512-PlhdFcillOINfeV7Ni6oF1TAEayyZBoZ8bcshTHqOYJYlrqzRK5hagpagky5o4HfCzzd1TRkXPMFq6cKk9rGmA==`
  )

  t.deepEqual(result, [
    {
      file,
      message: 'Parsed lock file has merge conflicts. Please fix them and try again.',
      type: 'ERROR'
    }
  ])
})

test('yarn@v1: should create error if file does not exist', async t => {
  const file = '/yarn-v1/not-existing/yarn.lock'
  const result = await checkLockFiles(file)

  t.deepEqual(result, [
    {
      file,
      message: 'Could not read lockfile: Unknown file /yarn-v1/not-existing/yarn.lock',
      type: 'ERROR'
    }
  ])
})

test('yarn@v2: correctly parses lockfile', async t => {
  const file = '/yarn-v2/correct/yarn.lock'
  const result = await checkMockedFile(file,
    `
# This file is generated by running "yarn install" inside your project.
# Manual changes might be lost - proceed with caution!

__metadata:
  version: 6
  cacheKey: 8
"lodash@npm:4.17.20, lodash@npm:^4.17.14, lodash@npm:^4.17.15, lodash@npm:^4.17.19":
  version: 4.17.20
  resolution: "lodash@npm:4.17.20"
  checksum: b31afa09739b7292a88ec49ffdb2fcaeb41f690def010f7a067eeedffece32da6b6847bfe4d38a77e6f41778b9b2bca75eeab91209936518173271f0b69376ea
  languageName: node
  linkType: hard

"@gitlab/example@workspace:packages/example":
  version: 0.0.0-use.local
  resolution: "@gitlab/example@workspace:packages/example"
  dependencies:
    "@gitlab/fonts": ^1.0.1
    "@gitlab/web-ide": "workspace:*"
    "@gitlab/web-ide-types": "workspace:*"
    "@types/lodash": 4.14.182
    "@vitejs/plugin-vue": ^3.0.1
    "@vue/tsconfig": ^0.1.3
    lodash: 4.17.20
    vite: ^3.0.4
    vue: ^3.2.37
    vue-tsc: ^0.39.5
  languageName: unknown
  linkType: soft
`
  )

  t.deepEqual(result, [])
})

// why: Yarn2 does something weird where it will automatically add this as a dependency
//      if it notices a script that needs it...
//      https://sourcegraph.com/github.com/yarnpkg/berry@@yarnpkg/shell/3.2.4/-/blob/packages/plugin-npm/sources/NpmSemverResolver.ts?L139
test.only('yarn@v2: correctly handles node-gyp: latest version', async t => {
  const file = '/yarn-v2/correct/yarn.lock'
  const result = await checkMockedFile(file,
    `
# This file is generated by running "yarn install" inside your project.
# Manual changes might be lost - proceed with caution!

__metadata:
  version: 6
  cacheKey: 8

"node-gyp@npm:latest":
  version: 9.0.0
  resolution: "node-gyp@npm:9.0.0"
  dependencies:
    env-paths: ^2.2.0
    glob: ^7.1.4
    graceful-fs: ^4.2.6
    make-fetch-happen: ^10.0.3
    nopt: ^5.0.0
    npmlog: ^6.0.0
    rimraf: ^3.0.2
    semver: ^7.3.5
    tar: ^6.1.2
    which: ^2.0.2
  bin:
    node-gyp: bin/node-gyp.js
  checksum: 4d8ef8860f7e4f4d86c91db3f519d26ed5cc23b48fe54543e2afd86162b4acbd14f21de42a5db344525efb69a991e021b96a68c70c6e2d5f4a5cb770793da6d3

"fsevents@npm:^2.3.2, fsevents@npm:~2.3.2":
  version: 2.3.2
  resolution: "fsevents@npm:2.3.2"
  dependencies:
    node-gyp: latest
  checksum: 97ade64e75091afee5265e6956cb72ba34db7819b4c3e94c431d4be2b19b8bb7a2d4116da417950c3425f17c8fe693d25e20212cac583ac1521ad066b77ae31f
  conditions: os=darwin
`
  )

  t.deepEqual(result, [])
})

test('package-lock.json: should create error because no support', async t => {
  const file = '/npm/package-lock.json'
  const result = await checkLockFiles(file)

  t.deepEqual(result, [
    {
      file,
      message: 'No support for lock files of type \'package-lock.json\'',
      type: 'ERROR'
    }
  ])
})

test('pnpm-lock.yaml: should create error because no support', async t => {
  const file = '/pnpm/pnpm-lock.yaml'
  const result = await checkLockFiles(file)

  t.deepEqual(result, [
    {
      file,
      message: 'No support for lock files of type \'pnpm-lock.yaml\'',
      type: 'ERROR'
    }
  ])
})
